/*
 * fslurp, Copyright (c) 2009 David Stone <ds.fslurp@asif.com>
 *
 * $RCSfile: externs.h,v $
 * $Revision: 1.5 $
 * $Date: 2012/09/02 19:10:31 $
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or 
 * implied warranty.
 */

#ifndef _EXTERNS_H_
#define _EXTERNS_H_

extern unsigned int		Verbose;
extern unsigned int		HeaderReport;
extern unsigned char		ResponseBuffer[];
extern struct GlobalData	InverterGlobals;
extern enum ReportTypeEnum	ReportType;
extern char*			Delimiter;
extern char*			TimeFormat;

extern const char* decodeCommand(unsigned char command);
extern const char* getInverterModel(unsigned char id);
extern unsigned char calculateChecksum(
	unsigned char* data, unsigned char length);
extern void dieMessage(int returnCode, char* format, ...);
extern void dieUsage(char* format, ...);
extern void inverterAllReport(
	struct InverterNowData nowData,
	struct InverterDayData dayData,
	struct InverterTotalData totalData);
extern void flushSerialPort(void);
extern void inverterDayReport(struct InverterDayData data);
extern void inverterHeaderReport(void);
extern void inverterNowReport(struct InverterNowData data);
extern void inverterTotalReport(struct InverterTotalData data);
extern void getActiveInverter(void);
extern void getDeviceType(void);
extern void getInverterDayData(struct InverterDayData* data);
extern void getInverterNowData(struct InverterNowData* data);
extern void getInverterTotalData(struct InverterTotalData* data);
extern void getVersion(void);
extern void hexDump(unsigned char* buffer, unsigned int length);
extern void readResponse(void);
extern void setBaudRate(char* baudRate);
extern void setSerialDevice(char* device);
extern void setupInverterGlobals();
extern void setupSerialPort(void);
extern void setupSerialPort(void);
extern void writeBytes(struct Request* request);

#endif /* _EXTERNS_H_ */
