/*
 * fslurp, Copyright (c) 2009 David Stone <ds.fslurp@asif.com>
 *
 * $RCSfile: utils.c,v $
 * $Revision: 1.2 $
 * $Date: 2009/10/25 22:38:17 $
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or 
 * implied warranty.
 */

#include "fslurp.h"

unsigned char calculateChecksum(
	unsigned char* data,
	unsigned char length)
{
	unsigned char	checkSum = 0;
	unsigned char	index;

	for (index = 0; index < length; index++)
	{
		checkSum += data[index];
	}

	return checkSum;
}

void hexDump(unsigned char* buffer, unsigned int length)
{
	unsigned int	i;

	assert(buffer != NULL);

	if (length == 0)
	{
		return;
	}

	for (i = 0; i < length; i++)
	{
		if ((i % 16) == 0)
		{
			fprintf(stderr, "\t");
		}

		fprintf(stderr, "%#02x ", buffer[i]);

		if ((i != 0) && ((i % 16) == 0))
		{
			fprintf(stderr, "\n");
		}
	}

	if ((i % 16) != 0)
	{
		fprintf(stderr, "\n");
	}
}
